/**
  Example program to demonstrate when signal handlers are needed.
  Orion Sky Lawlor, olawlor@acm.org, 2006/02/03 (Public Domain)
*/
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <setjmp.h>

jmp_buf backagain;
volatile int val=0;

void signal_handler(int sig) { /* <- Called when a SIGFPE occurs */
	static int hit_already=0;
	if (hit_already++!=0) {printf("Re-entered signal handler!\n");exit(1);}
	else printf("Inside signal handler--fixing val\n");
	val=2;
	longjmp(backagain,1); /* restart the divide instruction */
}

int main() {
	signal(SIGFPE,signal_handler); /* <- Listen for signal */
	
	setjmp(backagain);
	printf("Calling divide\n");
	int j=123/val;
	printf("Back from divide: %d\n",j);
	return 0;
}
